"""
URL configuration for learn project.

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib import admin
from django.urls import path, include
from . import views as ev
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
   
    path('exam_category', ev.exam_category,name='exam_category'),
    path('add_exam_category', ev.add_exam_category,name='add_exam_category'),
    path('edit_exam_category', ev.edit_exam_category,name='edit_exam_category'),
    path('delete_exam_category', ev.delete_exam_category, name='delete_exam_category'),

    
    path('exam_master', ev.examMaster,name='examMaster'),
    path('exam_master/add-exam', ev.addExam,name='addExam'),
    path('exam_master/edit-exam', ev.editExam,name='editExam'),
    path('exam_master/delete-exam', ev.deleteExamById,name='deleteExamById'),
    
    path('add-subject', ev.AddSubject,name='AddSubject'),


    path('faculty_module', ev.faculty_module,name='faculty_module'),
    path('add_faculty', ev.add_faculty,name='add_faculty'),
    path('edit_faculty', ev.edit_faculty,name='edit_faculty'),
    path('delete_faculty_by_Id', ev.delete_faculty_by_Id,name='delete_faculty_by_Id'),

    path('section_selct/', ev.section_selct,name='section_selct'),
    path('subsection_select/', ev.subsection_select,name='subsection_select'),

    path('question_bank', ev.all_question_bank,name='question-bank'),
    path('add-question/', ev.add_question,name='add-question'),
    path('upload_excel', ev.upload_excel,name='upload_excel'),
    path('upload_question_excel', ev.upload_data,name='upload_question_excel'),
    path('add_question_store/', ev.add_question_store,name='add_question_store'),
    path('editquestion/<int:id>', ev.editquestion,name='editquestion'),  
    # path('faculty-module/', ev.faculty_module,name='faculty-module'),

    path('mock_test', ev.mock_test_list, name='mock-test-list'),
    path('add-mock', ev.add_mock_test, name='add-mock'),
    path('edit_mock', ev.edit_mock, name='edit_mock'),
    path('delete_mock', ev.delete_mock, name='delete_mock'),
    path('search_mock/', ev.search_mock, name='search_mock'),
    path('add_mocktest/', ev.add_mocktest, name='add_mocktest'),
    # path('section/', ev.section, name='section'),
    # path('add_section/', ev.add_section, name='add_section'),

    path('section', ev.section, name='section'),
    path('add_section', ev.add_section, name='add_section'),
    path('edit_section', ev.edit_section,name='edit_section'),
    path('delete_section_by_Id', ev.delete_section_by_Id,name='delete_section_by_Id'),

    path('batch_management', ev.batch_managements, name='batch_management'),
    path('add_batch', ev.add_batch, name='add_batch'),
    path('edit_batch', ev.edit_batch, name='edit_batch'),
    path('delete_batch_by_Id', ev.delete_batch_by_Id,name='delete_batch_by_Id'),
    
    path('search_section/', ev.search_section, name='search_section'),

    path('sub_section', ev.sub_section, name='sub-section'),
    path('add_sub_section/', ev.add_sub_section, name='add_sub_section'),
    path('search_subsection/', ev.search_subsection, name='search_subsection'),

    path('topic_list', ev.topic_list, name='topic-list'),
    path('add_topic/', ev.add_topic, name='add_topic'),
    path('edit_topic/', ev.edit_topic, name='edit_topic'),
    path('delete_topic/', ev.delete_topic, name='delete_topic'),
    path('search_topic/', ev.search_topic, name='search_topic'),

    path('create-course/', ev.create_course, name='create-course'),
    # path('batch-management/', ev.batch_management, name='batch-management'),

    path('students', ev.Students_list, name='Students_list'),
    path('edit_student', ev.edit_student, name='edit_student'),
    path('delete_student', ev.delete_student, name='delete_student'),
    path('block_student', ev.block_student, name='block_student'),
    path('student_profile/<int:id>', ev.Student_Profile, name='Student_Profile'),

    path('lead_management', ev.Lead_Management, name='Lead_Management'),
    path('lead_view/<int:id>', ev.Lead_View, name='Lead_View'),

    path('live_lecture', ev.live_Lectures, name='live_Lectures'),
    path('live_lecture/add-lecture', ev.addLiveLecture, name='addLiveLecture'),
    path('live_lecture/delete-lecture', ev.deleteLiveLecturebyId, name='deleteLiveLecturebyId'),
    path('live_lecture/edit-lecture', ev.editLiveLecture, name='editLiveLecture'),
    path('live_lecture/search-lecture', ev.searchLiveLecture, name='searchLiveLecture'),
     path('live_lecture/video', ev.uploadVideobyLectureId, name='uploadVideobyLectureId'),

    path('blog_category', ev.blog_category, name='blog_category'),
    path('add_blog_category', ev.add_blog_category, name='add_blog_category'),
    path('edit_blog_category/', ev.edit_blog_category, name='edit_blog_category'),
    path('delete_blog_category/', ev.delete_blog_category, name='delete_blog_category'),
    path('search_blog_category/', ev.search_topic, name='search_blog_category'),

    path('blogs_list', ev.blogs_list, name='blogs-list'),
    path('add_blogs/', ev.add_blogs, name='add_blogs'),
    path('edit_blogs/', ev.edit_blogs, name='edit_blogs'),
    path('delete_blog/', ev.delete_topic, name='delete_blog'),
    path('search_blog/', ev.search_topic, name='search_blog'),

    path('banners', ev.banners,name='banners'),
    path('add_banner', ev.add_banner,name='add_banner'),
    path('edit_banner', ev.edit_banner,name='edit_banner'),
    path('delete_banner', ev.delete_banner, name='delete_banner'),

     path('courses', ev.courses,name='courses'),
    path('course_create', ev.course_create,name='course_create'),
    path('course_edit/<int:course_id>', ev.course_edit,name='course_edit'),

    path('select_exam_category', ev.select_exam_category,name='select_exam_category'),
    path('delete_course', ev.delete_course,name='delete_course'),

    path('media', ev.media,name='media'),
    path('add_Media', ev.addMedia,name='addMedia'),
    path('edit_Media', ev.editMedia,name='editMedia'),
    path('delete_Media', ev.deleteMediabyId,name='deleteMediabyId'),
    

    path('api/', include('apis.urls')),

]+static(settings.MEDIA_URL,document_root=settings.MEDIA_ROOT)

