import datetime
from django.core.paginator import Paginator
from django.shortcuts import get_object_or_404, redirect, render,HttpResponse
from django.http import JsonResponse
import openpyxl
from django.contrib import messages
# from django.core import serializers    
from learn.models import Banners, Course, ExamCategory, MediaModule,Sections,Sub_Sections,Question_Bank,Topics,Mock_Test,Faculty,Batch_Management,Students,Blogs,Blog_category,Option, Exam_Master, Exam_Subjects,Live_Lecture
from django.contrib.auth import authenticate, login
from django.contrib.auth.decorators import login_required
from django.contrib.auth.forms import AuthenticationForm
from learn.forms import UserRegisterForm

def login(request):
    return render(request, "login.html")

def login_process(request):
    # if request.method == 'POST':
  
    #     # AuthenticationForm_can_also_be_used__
  
    #     username = request.POST.get('username')
    #     password = request.POST.get('password')
    #     user = authenticate(request, username = username, password = password)
    #     if user is not None:
    #         form = login(request, user)
    #         messages.success(request, f' welcome {username} !!')
    #         return redirect('exam_category')
    #     else:
    #         messages.info(request, f'account done not exit plz sign in')
    # form = AuthenticationForm()

    if request.method == 'POST':
        username = request.POST.get('username')
        password = request.POST.get('password')
        user = authenticate(request, username=username, password=password)
        if user is not None:
            login(request, user)
            return redirect('exam_category')  # Redirect to home page after successful login
        else:
            return render(request, 'login.html', {'error': 'Invalid credentials.'})
    else:
        return render(request, 'login.html')

def registration(request):
    return render(request, "registration.html")

# def register_store(request):
#     if request.method == 'POST':
#         form = UserRegisterForm(request.POST)
#         if form.is_valid():
#             form.save()
#             username = form.cleaned_data.get('username')
#             email = form.cleaned_data.get('email')
#             ######################### mail system ####################################
#             htmly = get_template('user/Email.html')
#             d = { 'username': username }
#             subject, from_email, to = 'welcome', 'your_email@gmail.com', email
#             html_content = htmly.render(d)
#             msg = EmailMultiAlternatives(subject, html_content, from_email, [to])
#             msg.attach_alternative(html_content, "text/html")
#             msg.send()
#             ##################################################################
#             messages.success(request, f'Your account has been created ! You are now able to log in')
#             return redirect('login')
#     else:
#         form = UserRegisterForm()



def exam_category(request):
    all_categories = ExamCategory.objects.all()
    paginator = Paginator(all_categories, 10)  # Show 25 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "exam-category.html",{'all_categories':page_obj})

# def add_exam_category(request):
#     return render(request, "add_exam_category.html");

# def aboutUs(request):
#     return HttpResponse("welcome to django");

def all_question_bank(request):
    section_list = Sections.objects.all()
    Sub_Sections_list = Sub_Sections.objects.all()
    Topics_list = Topics.objects.all()
    Question_list = Question_Bank.objects.all()
    paginator = Paginator(Question_list, 10)  

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "all-questions-bank-list.html",{'Question_list':page_obj,'section_list':section_list,'Sub_Sections_list':Sub_Sections_list,'Topics_list':Topics_list})

def add_question(request):
    section_list = Sections.objects.all()
    Sub_Sections_list = Sub_Sections.objects.all()
    Topics_list = Topics.objects.all()
    return render(request, "add-question.html",{'section_list':section_list,'Sub_Sections_list':Sub_Sections_list,'Topics_list':Topics_list})

def upload_data(request):
    if request.method == 'POST' and request.FILES['excelFile']:
        excel_file = request.FILES['excelFile']

        # Load the Excel file
        wb = openpyxl.load_workbook(excel_file)
        sheet = wb.active

        questions_data = []
        options_data = []
        options = []
        # Iterate over the rows in the Excel file
        for row in sheet.iter_rows(min_row=2, values_only=True):
            section_id = row[0]
            subsection_id = row[1]
            topic_id = row[2]
            question_type = row[3]
            question = row[4]
            paragraph = row[5]
            option_1 = row[6]
            option_2 = row[7]
            option_3 = row[8]
            option_4 = row[9]
            correct_answer= row[10]
            answer_explaination = row[11]
            difficulty_level = row[12]
            marks = row[13]
            negative_marks = row[14]
            #  time_to_spent = row[7]
            status = 'Active'
            # options = row[12:]

            # Create a question object and append it to the questions_data list
            question_obj = Question_Bank(section_id=section_id, sub_section_id=subsection_id, topic_id=topic_id,
                                    question_type=question_type, question=question, paragraph=paragraph,
                                    difficulty_level=difficulty_level, marks=marks, negative_marks=negative_marks, explanation=answer_explaination,correct_answer=correct_answer, status=status,
                                   )
            questions_data.append(question_obj)
            option_data = [option_1, option_2, option_3, option_4]
            options.append(option_data)

        # Bulk insert the questions data
        Question_Bank.objects.bulk_create(questions_data)
        question_ids = list(Question_Bank.objects.filter(
            created_at__in=[question.created_at for question in questions_data]
        ).values_list('id', flat=True))

        # Retrieve the primary keys of the inserted questions
        #all_question_ids = [question.id for question in question_ids]

        options_data = []

        # Iterate over the rows again to get options data
        for index, row in enumerate(sheet.iter_rows(min_row=2, values_only=True)):
            
            question_id = question_ids[index]
            option_1 = row[6]
            option_2 = row[7]
            option_3 = row[8]
            option_4 = row[9]
            # Create option objects and append them to the options_data list
            if option_1:
                option_obj = Option(
                    question_id=question_id,
                    option=option_1
                )
                options_data.append(option_obj)   
            if option_2:
                option_obj = Option(
                    question_id=question_id,
                    option=option_2
                )
                options_data.append(option_obj)  
            if option_3:
                option_obj = Option(
                    question_id=question_id,
                    option=option_3
                )
                options_data.append(option_obj)  
            if option_4:
                option_obj = Option(
                    question_id=question_id,
                    option=option_4
                )
                options_data.append(option_obj)  

        # Bulk insert the options data
        Option.objects.bulk_create(options_data)
        return JsonResponse({'message': 'Data uploaded successfully.', 'section': question_ids})

    return render(request, 'upload.html')


def delete_exam_category(request):  
    # id= request.POST.get('id')
    # examcategory = ExamCategory.objects.get(id=id)  
    # examcategory.delete() 
    # return JsonResponse({'status': 'success', 'msg': 'Exam Category Deleted successfully.'})
    id = request.GET.get('id')
    
    ExamCategory(id).soft_delete()
    return JsonResponse({'status': 'success', 'msg': 'Exam category deleted successfully.'})


 # ================ faculty module ==========================


def faculty_module(request):
    all_faculties = Faculty.objects.all()
    paginator = Paginator(all_faculties, 10)  # Show 2 contacts per page.
    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "faculty_module.html",{'all_faculties':page_obj});

def add_faculty(request):

    if request.method == 'POST':
        # Get the form data
        faculty_name = request.POST.get('faculty_name')
        email = request.POST.get('email')
        password = request.POST.get('password')
        contact = request.POST.get('contact')
        experience = request.POST.get('experience')
        date_of_birth = request.POST.get('date_of_birth')
        status = request.POST.get('status')
       
        if(faculty_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter faculty name.'})
        elif(email==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter faculty email.'})
        elif(password==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter password.'})
        elif(contact==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter contact number.'})
        elif(experience==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter experience.'})
        elif(date_of_birth==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter date_of_birth.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            faculty = Faculty(
                faculty_name=faculty_name,
                email = email,
                password=password,
                contact= contact,
                experience= experience,
                date_of_birth = date_of_birth,
                status=status
            )

            # Save the object to the database
            faculty.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Faculty added successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})


def edit_faculty(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        faculty_name = request.POST.get('name')
        email = request.POST.get('email')
        password = request.POST.get('password')
        contact = request.POST.get('contact')
        experience = request.POST.get('experience')
        date_of_birth = request.POST.get('dob')
        status = request.POST.get('status')
       
        if(faculty_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter faculty name.'})
        elif(email==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter faculty email.'})
        elif(password==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter password.'})
        elif(contact==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter contact number.'})
        elif(experience==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter experience.'})
        elif(date_of_birth==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter date_of_birth.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            faculty = Faculty(
                id=id,
                faculty_name=faculty_name,
                email = email,
                password=password,
                contact= contact,
                experience= experience,
                date_of_birth = date_of_birth,
                status=status
            )

            # Save the object to the database
            faculty.save(update_fields=["faculty_name","email","password","contact","experience","date_of_birth","status"])

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Faculty added successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_faculty_by_Id(request):
     id = request.POST.get('id')
    #  print(id)
     Faculty(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'faculty deleted successfully.'})        
   
# =====================section module start ==================================

def section(request):
    all_section = Sections.objects.all();
    paginator = Paginator(all_section, 10)  # Show 25 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)

    return render(request, "section.html",{'all_section':page_obj});


def add_section(request):
    if request.method == 'POST':
        # Get the form data
        section_name = request.POST.get('section_name')
        status = request.POST.get('status')
        display_order = request.POST.get('display_order')
        if(section_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter section name.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            section = Sections(
                section_name=section_name,
                display_order=display_order,
                status=status
            )

            # Save the object to the database
            section.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Section created successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
    
def edit_section(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        section_name = request.POST.get('name')
        status = request.POST.get('status')
        display_order = request.POST.get('display_order')
        if(section_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter section name.'})
        elif(display_order==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Display order.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    

            section = Sections(
                    id=id,
                    section_name=section_name,
                    display_order=display_order,
                    status=status
                )
            section.save(update_fields=["section_name","display_order","status"])
            # Return a success response

            return JsonResponse({'status': 'success', 'msg': 'Exam category saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_section_by_Id(request):
     id = request.POST.get('id')
    #  print(id)
     Sections(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'section deleted successfully.'})


# ======================= end section module =============================

# ====================== start batch management ========================

def batch_managements(request):
    all_batches = Batch_Management.objects.all()
    paginator = Paginator(all_batches, 10)  # Show 10 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)

    return render(request, "batch-management.html",{'all_batches':page_obj});

def add_batch(request):
    if request.method == 'POST':
        # Get the form data
        batch_name = request.POST.get('batch_name')
        couse_name = request.POST.get('couse_name')
        status = request.POST.get('status')
       
        if(batch_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter batch name.'})
        if(couse_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select course.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            batch = Batch_Management(
                batch_name=batch_name,
                couse_name=couse_name,
                status=status
            )

            # Save the object to the database
            batch.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Created Batch successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def edit_batch(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        batch_name = request.POST.get('name')
        couse_name = request.POST.get('c_name')
        status = request.POST.get('status')
       
        if(batch_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter batch name.'})
        
        elif(couse_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter course name.'})
        
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    

            batch = Batch_Management(
                    id=id,
                    batch_name=batch_name,
                    couse_name=couse_name,
                    status=status
                )
            batch.save(update_fields=["batch_name","couse_name","status"])
            # Return a success response

            return JsonResponse({'status': 'success', 'msg': 'batch created successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_batch_by_Id(request):
     id = request.POST.get('id')
    #  print(id)
     Batch_Management(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'section deleted successfully.'})
# ==============================end batch_management===========================



def section_selct(request): 
    section_id = request.GET.get('section')
    sub_section = Sub_Sections.objects.filter(section_id=section_id)
    return render(request, "select_sub_section.html" ,{'sub_section':sub_section})
   

def subsection_select(request):  
    sub_section_id = request.GET.get('sub_section')
    topic = Topics.objects.filter(sub_section_id=sub_section_id)
    return render(request, "select_topic.html" ,{'topic':topic})

def editquestion(request, id): 
    section_list = Sections.objects.all()
    Sub_Sections_list = Sub_Sections.objects.all()
    Topics_list = Topics.objects.all() 
    Question_list = Question_Bank.objects.get(id=id) 
    return render(request,'edit-question.html', {'Question_list':Question_list,'section_list':section_list,'Sub_Sections_list':Sub_Sections_list,'Topics_list':Topics_list})

def batch_management(request):
    return render(request, "batch-management.html");

def create_course(request):
    return render(request, "create-course.html");


def mock_test_list(request):
    all_categories = ExamCategory.objects.all()
    mock_test = Mock_Test.objects.all()
    paginator = Paginator(mock_test, 10)  # Show 25 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "mock-test.html",{'mock_test_list':page_obj,'all_categories':all_categories})

def add_mock_test(request):
    section_list = Sections.objects.all()
    Sub_Sections_list = Sub_Sections.objects.all()
    Topics_list = Topics.objects.all()
    all_categories = ExamCategory.objects.all()
    return render(request, "mock-test-list-add.html",{'all_categories':all_categories,'section_list':section_list,'Sub_Sections_list':Sub_Sections_list,'Topics_list':Topics_list})

# def section(request):
#     section_list = Sections.objects.all()
#     # print(section_list)
#     return render(request, "section.html" ,{'section_list':section_list})

def search_section(request):
    search = request.GET.get('search')
    section_list = Sections.objects.filter(section_name__startswith=search)
    # print(section_list)
    return render(request, "search_section.html" ,{'section_list':section_list})

def search_subsection(request):
    search = request.GET.get('search')
    Sub_Sections_list = Sub_Sections.objects.filter(sub_section_name__startswith=search)
    # print(section_list)
    return render(request, "search_subsection.html" ,{'Sub_Sections_list':Sub_Sections_list})

def search_topic(request):
    search = request.GET.get('search')
    topics = Topics.objects.filter(topic_name__startswith=search)
    # print(section_list)
    return render(request, "search_topic.html" ,{'Topic_list':topics})

def search_mock(request):
    search = request.GET.get('search')
    mock_test_list = Mock_Test.objects.filter(mock_title__startswith=search)
    # print(section_list)
    return render(request, "search_mock.html" ,{'mock_test_list':mock_test_list})

def sub_section(request):
    section_list = Sections.objects.all()
    Sub_Sections_list = Sub_Sections.objects.select_related('section')
    return render(request, "sub-section.html",{'Sub_Sections_list':Sub_Sections_list,'section_list':section_list})
def topic_list(request):
    section_list = Sections.objects.all()
    Sub_Sections_list = Sub_Sections.objects.all()
    #Topic_list = Topics.objects.all().select_related('learn_sections','learn_sub_sections')
    Topic_list = Topics.objects.select_related('section', 'sub_section')
    # Question_list = Question_Bank.objects.select_related('section', 'sub_section', 'topic').prefetch_related('option_set')

    return render(request, "Topic-list.html",{'Topic_list':Topic_list,'Sub_Sections_list':Sub_Sections_list,'section_list':section_list})

# def Students(request):
#     student_list = Students.objects.all()
#     # Sub_Sections_list = Sub_Sections.objects.all()
#     # Topic_list = Topics.objects.all()
#     return render(request, "student_module.html",{'student_list':student_list})

# Define the view that handles the Ajax requestuest

def add_topic(request):
    if request.method == 'POST':
        # Get the form data
        section = request.POST.get('section')
        sub_section = request.POST.get('sub_section')
        topic_name = request.POST.get('topic_name')
        display_order = request.POST.get('display_order')
        status = request.POST.get('status')
        # image = request.FILES.get('image')
        if(topic_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Section name.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            section = Topics(
                section_id=section,
                sub_section_id=sub_section,
                topic_name=topic_name,
                display_order=display_order,
                status=status
            )

            # Save the object to the database
            section.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Topic saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
    
def add_mocktest(request):
    if request.method == 'POST':
        # Get the form data
        mock_title = request.POST.get('mock_title')
        mock_type = request.POST.get('mock_type')
        section_id = request.POST.get('section_id')
        sub_section_id = request.POST.get('sub_section_id')
        topic_id = request.POST.get('topic_id')
        exam_category = request.POST.get('exam_category')
        mock_level = request.POST.get('mock_level')
        mock_duration = request.POST.get('mock_duration')
        pass_per = request.POST.get('pass_per')
        negative_marks = request.POST.get('negative_marks')
        instruction_page = request.POST.get('instruction_page')
        # image = request.FILES.get('image')
        if(mock_title==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Section name.'})
        else:    
            # Create a new ExamCategory object
            section = Mock_Test(
                mock_title=mock_title,
                mock_type=mock_type,
                section_id=section_id,
                sub_section_id=sub_section_id,
                topic_id=topic_id,
                examcategory_id=exam_category,
                mock_level=mock_level,
                pass_per=pass_per,
                negative_marks=negative_marks,
                instruction_page=instruction_page,
                mock_duration=mock_duration
            )

            # Save the object to the database
            section.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Mock Test saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
    
# def add_section(request):
#     if request.method == 'POST':
#         # Get the form data
#         section_name = request.POST.get('section_name')
#         display_order = request.POST.get('display_order')
#         status = request.POST.get('status')
#         # image = request.FILES.get('image')
#         if(section_name==''):
#             return JsonResponse({'status': 'error', 'msg': 'Please enter Section name.'})
#         elif(status==''):
#             return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
#         else:    
#             # Create a new ExamCategory object
#             section = Sections(
#                 section_name=section_name,
#                 display_order=display_order,
#                 status=status
#             )

#             # Save the object to the database
#             section.save()

#             # Return a success response
#             return JsonResponse({'status': 'success', 'msg': 'Exam Section saved successfully.'})
#     else:
#         # Return an error response
#             return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
def add_sub_section(request):
    if request.method == 'POST':
        # Get the form data
        section_name = request.POST.get('section_id')
        sub_section_name = request.POST.get('sub_section_name')
        display_order = request.POST.get('display_order')
        status = request.POST.get('status')
        # image = request.FILES.get('image')
        if(section_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Section name.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            section = Sub_Sections(
                section_id=section_name,
                sub_section_name =sub_section_name,
                display_order=display_order,
                status=status
            )

            # Save the object to the database
            section.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Sub Section saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
        
def add_question_store(request):
    if request.method == 'POST':
        # Get the form data
        section_id = request.POST.get('section_id')
        sub_section_id = request.POST.get('sub_section_id')
        topic = request.POST.get('topic')
        question_type = request.POST.get('question_type')
        difficulty_level = request.POST.get('difficulty_level')
        time_to_speed = request.POST.get('time_to_speed')
        question = request.POST.get('editor1')
        explanation = request.POST.get('editor2')
        status = request.POST.get('status')
        question_file = request.FILES.get('question_file')
        # image = request.FILES.get('image')
        if(section_id==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Section name.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            section = Question_Bank(
                section_id=section_id,
                sub_section_id=sub_section_id,
                topic_id=topic,
                question_type=question_type,
                difficulty_level=difficulty_level,
                time_to_speed=time_to_speed,
                question=question,
                explanation=explanation,
                question_file=question_file,
                status=status
            )

            # Save the object to the database
            section.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Exam Section saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
def upload_excel(request):
    if request.method == 'POST':

        # excel_file = request.FILES["excel_file"]
        excel_file = request.FILES.get('excel_file')
        print(excel_file)
        # you may put validations here to check extension or file size

        wb = openpyxl.load_workbook(excel_file)

        # getting a particular sheet by name out of many sheets
        worksheet = wb["Sheet1"]
        print(worksheet)

        excel_data = list()
        # iterating over the rows and
        # getting value from each cell in row
        for row in worksheet.iter_rows():
            row_data = list()
            # print(row)
            for cell in row:
                print(cell.value)
                row_data.append(str(cell.value))
            excel_data.append(row_data)
            # print(row_data)
            return HttpResponse('<h2> form submitted.</h2>')
        # data = serializers.serialize('xml/json', excel_data)    
        # print(data)
        # Get the form data
        # section_id = request.POST.get('section_id')
        # sub_section_id = request.POST.get('sub_section_id')
        # topic = request.POST.get('topic')
        # question_type = request.POST.get('question_type')
        # difficulty_level = request.POST.get('difficulty_level')
        # time_to_speed = request.POST.get('time_to_speed')
        # question = request.POST.get('editor1')
        # explanation = request.POST.get('editor2')
        # status = request.POST.get('status')
        # question_file = request.FILES.get('question_file')
        # # image = request.FILES.get('image')
        # if(section_id==''):
        #     return JsonResponse({'status': 'error', 'msg': 'Please enter Section name.'})
        # elif(status==''):
        #     return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        # else:    
        #     # Create a new ExamCategory object
        #     section = Question_Bank(
        #         section_id=section_id,
        #         sub_section_id=sub_section_id,
        #         topic_id=topic,
        #         question_type=question_type,
        #         difficulty_level=difficulty_level,
        #         time_to_speed=time_to_speed,
        #         question=question,
        #         explanation=explanation,
        #         question_file=question_file,
        #         status=status
        #     )

        #     # Save the object to the database
        #     section.save()

            # Return a success response
        # return JsonResponse(worksheet)
            # return JsonResponse({'status': 'success', 'msg': 'Exam Section saved successfully.'})
    else:
        # Return an error response
        return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
        
def add_exam_category(request):
    if request.method == 'POST':
        # Get the form data
        exam_category_name = request.POST.get('exam_category_name')
        status = request.POST.get('status')
        image = request.FILES.get('image')
        if(exam_category_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter category name.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            category = ExamCategory(
                exam_category_name=exam_category_name,
                image=image,
                status=status
            )

            # Save the object to the database
            category.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Exam category saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
    
def edit_exam_category(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        exam_category_name = request.POST.get('name')
        status = request.POST.get('status')
        image = request.FILES.get('image')
        if(exam_category_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter category name.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            if(request.FILES.get('image')):
                # Create a new ExamCategory object
                category = ExamCategory(
                    id=id,
                    exam_category_name=exam_category_name,
                    image=image,
                    status=status
                )

                # Save the object to the database
                category.save(update_fields=["exam_category_name","image","status"])
                category.save()
            else:
                 # Create a new ExamCategory object
                category = ExamCategory(
                    id=id,
                    exam_category_name=exam_category_name,
                    status=status
                )

                # Save the object to the database
                category.save(update_fields=["exam_category_name","status"])
            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Exam category saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

        
def edit_topic(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('topic_id')
        section = request.POST.get('edit_section')
        sub_section = request.POST.get('edit_sub_section')
        topic_name = request.POST.get('tname')
        display_order = request.POST.get('d_order')
        status = request.POST.get('edit_status')
        if(topic_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Topic name.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
           
                 # Create a new ExamCategory object
            topic = Topics(
                id=id,
                section_id=section,
                sub_section_id=sub_section,
                topic_name=topic_name,
                display_order=display_order,
                status=status
            )

            # Save the object to the database
            topic.save(update_fields=["section_id","sub_section_id","sub_section_id","topic_name","display_order","status"])
            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Topic Updated successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_topic(request):  
   
    id = request.GET.get('id')
    
    Topics(id).soft_delete()
    return JsonResponse({'status': 'success', 'msg': 'Topic deleted successfully.'})
     
def edit_mock(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('mock_id')
        mock_title = request.POST.get('mock_title')
        mock_type = request.POST.get('mock_type')
        exam_category = request.POST.get('exam_category')
        mock_level = request.POST.get('mock_level')
        mock_duration = request.POST.get('mock_duration')
        pass_per = request.POST.get('pass_per')
        negative_marks = request.POST.get('negative_marks')
        instruction_page = request.POST.get('instruction_page')
        if(mock_title==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Mock Title name.'})
        elif(exam_category==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select Exam category.'})
        else:    
           
                 # Create a new ExamCategory object
            mock = Mock_Test(
                id=id,
                mock_title=mock_title,
                mock_type=mock_type,
                examcategory_id=exam_category,
                mock_level=mock_level,
                pass_per=pass_per,
                negative_marks=negative_marks,
                instruction_page=instruction_page,
                mock_duration=mock_duration
            )

            # Save the object to the database
            mock.save(update_fields=["mock_title","mock_type","examcategory_id","mock_level","pass_per","negative_marks","instruction_page","mock_duration"])
            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Mock Test Updated successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_mock(request):  
   
    id = request.GET.get('id')
    
    Mock_Test(id).soft_delete()
    return JsonResponse({'status': 'success', 'msg': 'MOck Test deleted successfully.'})
     

# =============================start student module ===============================
def Students_list(request):
    student_list = Students.objects.filter(is_lead=0)
    # Batch_Management = Batch_Management.objects.all()
    paginator = Paginator(student_list, 10)  

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "student_module.html",{'student_list':page_obj})

def edit_student(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('student_id')
        first_name = request.POST.get('fname')
        last_name = request.POST.get('lname')
        email = request.POST.get('email')
        mobile = request.POST.get('contact')
        address = request.POST.get('address')
        city = request.POST.get('city')
        state = request.POST.get('state')
        pincode = request.POST.get('pincode')
        if(first_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter First name.'})
        else:    
           
                 # Create a new ExamCategory object
            mock = Students(
                id=id,
                first_name=first_name,
                last_name=last_name,
                email=email,
                mobile=mobile,
                address=address,
                city=city,
                state=state,
                pincode=pincode
            )

            # Save the object to the database
            mock.save(update_fields=["first_name","last_name","email","mobile","address","city","state","pincode"])
            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Student Updated successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_student(request):  
   
    id = request.GET.get('id')    
    Students(id).soft_delete()
    return JsonResponse({'status': 'success', 'msg': 'Student deleted successfully.'})
 
def block_student(request):  
   
    # id = request.GET.get('id')  
    id = request.POST.get('student_id')
    student_list = Students.objects.get(id=id)
    remark = request.POST.get('remark')
    if student_list.status == 'Active':
        status = 'Inactive' 
    else:
        status = 'Active' 
    student = Students(
                id=id,
                remark=remark,
                status= status
            )
    student.save(update_fields=["remark","status"])
            # Return a success response
    return JsonResponse({'status': 'success', 'msg': 'Student Updated successfully.'})

def Student_Profile(request,id):
    student_list = Students.objects.get(id=id)
    return render(request, "student_profile.html",{'student_list':student_list})
# =================================end student module ========================


# ==================== start lead management =============================
def Lead_Management(request):
    student_list = Students.objects.filter(is_lead=1)
    # Batch_Management = Batch_Management.objects.all()
    paginator = Paginator(student_list, 10)  

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "lead_management.html",{'student_list':page_obj})
def Lead_View(request):
    student_list = Students.objects.get(id=id)
    return render(request, "lead_view.html",{'student_list':student_list})
# ==================== end lead management =============================

# ===================== start live lecture module ========================

def live_Lectures(request):
    batch_list = Batch_Management.objects.all()
    topics_list = Topics.objects.all()
    faculty_list = Faculty.objects.all()
    all_lectures = Live_Lecture.objects.all()
    paginator = Paginator(all_lectures, 10)  # Show 10 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)

    return render(request, "live_lecture.html",{'all_lectures':page_obj,
    'batch_list':batch_list,'topics_list':topics_list,'faculty_list':faculty_list }
    );
    
def addLiveLecture(request):
    if request.method == 'POST':
        # Get the form data
        title = request.POST.get('title')
        batch = request.POST.get('batch')
        subject = request.POST.get('subject')
        topic = request.POST.get('topic')
        image = request.FILES.get('image')
        faculty = request.POST.get('faculty')
        lacture_id = request.POST.get('lacture_id')
        
        lacture_date = request.POST.get('lacture_date')
        start_time = request.POST.get('start_time')
        end_time = request.POST.get('end_time')
        password = request.POST.get('password')
       
        if(title==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter the title .'})
        elif(batch==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select batch.'})
        elif(subject==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select subject.'})

        elif(topic==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select topic.'})
        elif(image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select image.'})
        elif(faculty==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select faculty.'})
        elif(lacture_id==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter lacture id'})
        elif(lacture_date==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select lacture date'})
        elif(start_time==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select start time'})
        elif(end_time==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select end time '})
        elif(password==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter password '})
        else:    
            # Create a new ExamCategory object
            category = Live_Lecture(
                title=title,
                batch_id=batch,
                subject=subject,
                topic_id=topic,
                image=image,
                faculty_id=faculty,
                lacture_id=lacture_id,
                lacture_date=lacture_date,
                start_time=start_time,
                end_time=end_time,
                password=password
            )

            # Save the object to the database
            category.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'live lecture info  saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
     
def editLiveLecture(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        title = request.POST.get('title')
        batch = request.POST.get('batch')
        subject = request.POST.get('subject')
        topic = request.POST.get('topic')
        image = request.FILES.get('image')
        faculty = request.POST.get('faculty')
        lacture_id = request.POST.get('lacture_id')
        
        lacture_date = request.POST.get('lacture_date')
        start_time = request.POST.get('start_time')
        end_time = request.POST.get('end_time')
        password = request.POST.get('password')
       
        if(title==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter the title .'})
        elif(batch==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select batch.'})
        elif(subject==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select subject.'})

        elif(topic==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select topic.'})
        elif(image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select image.'})
        elif(faculty==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select faculty.'})
        elif(lacture_id==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter lacture id'})
        elif(lacture_date==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select lacture date'})
        elif(start_time==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select start time'})
        elif(end_time==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select end time '})
        elif(password==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter password '})
        else:
            if(request.FILES.get('image')):
                  # Create a new ExamCategory object
                lecture = Live_Lecture(
                id=id,
                title=title,
                batch_id=batch,
                subject=subject,
                topic_id=topic,
                image=image,
                faculty_id=faculty,
                lacture_id=lacture_id,
                lacture_date=lacture_date,
                start_time=start_time,
                end_time=end_time,
                password=password
                )

                lecture.save(update_fields=["title","batch_id","subject","topic_id","image","faculty_id","lacture_id","lacture_date","start_time","end_time","password"])
               # Return a success response
                return JsonResponse({'status': 'success', 'msg': 'Lecture Details Updated successfully.'})
            else:
                 # Create a new ExamCategory object
                category = Live_Lecture(
                    id=id,
                    title=title,
                    batch_id=batch,
                    subject=subject,
                    topic_id=topic,
                    faculty_id=faculty,
                    lacture_id=lacture_id,
                    lacture_date=lacture_date,
                    start_time=start_time,
                    end_time=end_time,
                    password=password
                    )
                lecture.save(update_fields=["title","batch_id","subject","topic_id","faculty_id","lacture_id","lacture_date","start_time","end_time","password"])
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def deleteLiveLecturebyId(request):
     id = request.POST.get('id')
    #  print(id)
     Live_Lecture(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'lecture deleted successfully.'})

def uploadVideobyLectureId(request):
    if request.method == 'POST':
        id = request.POST.get('id')
        thumbnail = request.FILES.get('thumbnail')
        video_description = request.POST.get('video_description')
        videos = request.FILES.get('video-lecture')
        if(thumbnail==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select thumbnail .'})
        elif(video_description==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter video description.'})
        elif(videos==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select video file to upload'})
        else:    
            # Create a new ExamCategory object
            video = Live_Lecture(
                id=id,
                thumbnail=thumbnail,
                video_description=video_description,
                videos=videos,
               
            )

            # Save the object to the database
            video.save(update_fields=["thumbnail","video_description","videos"])

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'live lecture info  saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})


def searchLiveLecture(request):
    search = request.GET.get('search')
    all_lectures = Live_Lecture.objects.filter(title__startswith=search)
    # print(section_list)
    return render(request, "search_live_lecture.html" ,{'all_lectures':all_lectures})

# ===================== end live lecture module ========================


def examMaster(request):
    section_list = Sections.objects.all()
    all_categories = ExamCategory.objects.all()
    all_exams = Exam_Master.objects.all()
    paginator = Paginator(all_exams, 10)  # Show 25 contacts per page.
    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "exam-master.html",{'all_exams':page_obj,'section_list':section_list,'all_categories':all_categories})

def addExam(request):
    if request.method == 'POST':
        # Get the form data
        category_id= request.POST.get('category_id')
        exam_name = request.POST.get('exam_name')
        marks_per_question = request.POST.get('marks_per_question')
        negative_marks_per_question = request.POST.get('negative_marks_per_question')
        status = request.POST.get('status')
        image = request.FILES.get('image')
        banner = request.FILES.get('banner')
        if(exam_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter exam name.'})
        elif(category_id==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select category'})
        elif(marks_per_question==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter marks per question'})
        elif(negative_marks_per_question==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter negative marks per question'})
        elif(image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select image.'})
        elif(banner==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select banner.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            category = Exam_Master(
                exam_category_id=category_id,
                exam_name=exam_name,
                image=image,
                banner=banner,
                marks_per_question=marks_per_question,
                negative_marks_per_question=negative_marks_per_question,
                status=status
            )

            # Save the object to the database
            category.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Exam saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def editExam(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        exam_name = request.POST.get('exam_name')
        marks_per_question = request.POST.get('marks_per_question')
        negative_marks_per_question = request.POST.get('negative_marks_per_question')
        status = request.POST.get('status')
        image = request.FILES.get('image')
        banner = request.FILES.get('banner')

        if(exam_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter exam name.'})
        elif(marks_per_question==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter marks per question'})
        elif(negative_marks_per_question==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter negative marks per question'})
        elif(image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select image.'})
        elif(banner==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select banner.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:
            if(request.FILES.get('image')):
                # Create a new ExamCategory object
                    exam = Exam_Master(
                        id=id,
                        exam_name=exam_name,
                        image=image,
                        banner=banner,
                        marks_per_question=marks_per_question,
                        negative_marks_per_question=negative_marks_per_question,
                        status=status
                    )

                # Save the object to the database
                    exam.save(update_fields=["exam_name","image","banner","marks_per_question","negative_marks_per_question","status"])
                    exam.save()
            else:
                 # Create a new ExamCategory object
                    exam = Exam_Master(
                    id=id,
                    exam_name=exam_name,
                    banner=banner,
                    marks_per_question=marks_per_question,
                    negative_marks_per_question=negative_marks_per_question,
                    status=status
                     )

                # Save the object to the database
                    exam.save(update_fields=["exam_name","banner","marks_per_question","negative_marks_per_question","status"])


            # Return a success response
        return JsonResponse({'status': 'success', 'msg': 'Exam saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})


def deleteExamById(request):
     id = request.POST.get('id')
    #  print(id)
     Exam_Master(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'Exam deleted successfully.'})

def AddSubject(request):
     section_id = request.POST.getlist('section_id')
     id = request.POST.get('id')
     for section in section_id:
        subject = Exam_Subjects(
                exam_id=id,
                section_id=section,
               
        )
            # Save the object to the database
        subject.save()
    #  print(section_id,id)
     return JsonResponse({'status': 'success', 'msg': 'subject added successfully.'})

# =========================end exam master =============================


# ====================== start Blog category ========================

def blog_category(request):
    blog_category = Blog_category.objects.all()
    # all_blogs = Blogs.objects.all()
    paginator = Paginator(blog_category, 10)  # Show 10 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)

    return render(request, "blog_category.html",{'blog_category_list':page_obj});

def add_blog_category(request):
    if request.method == 'POST':
        # Get the form data
        Blog_category_name = request.POST.get('Blog_category_name')
        meta_title = request.POST.get('meta_title')
        meta_discription = request.POST.get('meta_discription')
        slug = request.POST.get('slug')
        blog_image = request.FILES.get('image')
        status = request.POST.get('status')
       
        if(Blog_category_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter blog title.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            blog = Blog_category(               
                category_name=Blog_category_name,
                meta_title=meta_title,
                meta_discription=meta_discription,
                slug=slug,
                blog_category_image=blog_image,
                status=status
            )

            # Save the object to the database
            blog.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Created Blog Category successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def edit_blog_category(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        Blog_category_name = request.POST.get('Blog_category_name')
        meta_title = request.POST.get('meta_title')
        meta_discription = request.POST.get('meta_discription')
        slug = request.POST.get('slug')
        blog_image = request.FILES.get('image')
        status = request.POST.get('status')
       
        if(Blog_category_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter blog category name.'})
        
        elif(meta_title==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Meta title.'})
        elif(meta_discription==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter meta description.'})
        elif(slug==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter slug.'})
        elif(blog_image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select imgage.'})
        
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    

            batch = Blog_category(
                id=id,
                category_name=Blog_category_name,
                meta_title=meta_title,
                meta_discription=meta_discription,
                slug=slug,
                blog_category_image=blog_image,
                status=status
            )
            batch.save(update_fields=["category_name","meta_title","meta_discription","slug","blog_category_image","status"])
            # Return a success response

            return JsonResponse({'status': 'success', 'msg': 'Blog Category Updated successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_blog_category(request):
     id = request.POST.get('id')
    #  print(id)
     Blog_category(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'section deleted successfully.'})

def search_blog_category(request):
    search = request.GET.get('search')
    blog_category = Blog_category.objects.filter(category_name__startswith=search)
    # print(section_list)
    return render(request, "search_blog_category.html" ,{'blog_category':blog_category})
# ==============================end Blog Category===========================
# ====================== start Blog Post ========================

def blogs_list(request):
    blog_category = Blog_category.objects.all()
    all_blogs = Blogs.objects.all()
    paginator = Paginator(all_blogs, 10)  # Show 10 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)

    return render(request, "blogs_list.html",{'all_blogs':page_obj,'blog_category':blog_category});

def add_blogs(request):
    if request.method == 'POST':
        # Get the form data
        blog_category = request.POST.get('blog_category')
        blog_title = request.POST.get('blog_title')
        blog_discription = request.POST.get('blog_discription')
        meta_title = request.POST.get('meta_title')
        meta_discription = request.POST.get('meta_discription')
        slug = request.POST.get('slug')
        blog_image = request.FILES.get('blog_image')
        status = request.POST.get('status')
       
        if(blog_title==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter blog title.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            blog = Blogs(
                category_id=blog_category,
                blog_title=blog_title,
                blog_discription=blog_discription,
                meta_title=meta_title,
                meta_discription=meta_discription,
                slug=slug,
                blog_image=blog_image,
                blog_status=status
            )

            # Save the object to the database
            blog.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Created Blog successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def edit_blogs(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        blog_category = request.POST.get('blog_category')
        blog_title = request.POST.get('blog_title')
        blog_discription = request.POST.get('blog_discription')
        meta_title = request.POST.get('meta_title')
        meta_discription = request.POST.get('meta_discription')
        slug = request.POST.get('slug')
        blog_image = request.FILES.get('blog_image')
        status = request.POST.get('status')
       
        if(blog_title==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Blog name.'})
        
        elif(blog_category==''):
            return JsonResponse({'status': 'error', 'msg': 'Please Select Blog Category.'})
        
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    

            batch = Blogs(
                    id=id,
                    category_id=blog_category,
                    blog_title=blog_title,
                    blog_discription=blog_discription,
                    meta_title=meta_title,
                    meta_discription=meta_discription,
                    slug=slug,
                    blog_image=blog_image,
                    blog_status=status
                )
            batch.save(update_fields=["category_id","blog_title","blog_discription","meta_title","meta_discription","slug","blog_image","blog_status"])
            # Return a success response

            return JsonResponse({'status': 'success', 'msg': 'Blog Updated successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def delete_blog(request):
     id = request.POST.get('id')
    #  print(id)
     Blogs(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'Blog deleted successfully.'})

def search_blog(request):
    search = request.GET.get('search')
    blogs = Blogs.objects.filter(blog_title__startswith=search)
    # print(section_list)
    return render(request, "search_blog.html" ,{'blogs':blogs})
# ==============================end Blog Post ===========================

# ============================start banner =============================
def banners(request):
    section_list = Sections.objects.all()
    all_banner = Banners.objects.all()
    paginator = Paginator(all_banner, 10)  # Show 25 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "banner.html",{'all_banner':page_obj,'section_list':section_list})

        
def add_banner(request):
    if request.method == 'POST':
        # Get the form data
        banner_image = request.FILES.get('image')
        section = request.POST.get('section_id')
        status = request.POST.get('status')
        redirect_url = request.POST.get('redirect_url')
        
        if(banner_image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select banner.'})
        elif(section==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select section.'})
        elif(redirect_url==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Redirect url.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            # Create a new ExamCategory object
            banner = Banners(
                banner_image=banner_image,
                section_id=section,
                redirect_url=redirect_url,
                status=status
            )

            # Save the object to the database
            banner.save()

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Exam category saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})
    
def edit_banner(request):
    if request.method == 'POST':
        # Get the form data
        id = request.POST.get('id')
        banner_image = request.FILES.get('image')
        section = request.POST.get('section_id')
        status = request.POST.get('status')
        redirect_url = request.POST.get('redirect_url')
        if(banner_image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select banner.'})
        elif(section==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select section.'})
        elif(redirect_url==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter Redirect url.'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:    
            if(request.FILES.get('image')):
                # Create a new ExamCategory object
                banner = Banners(
                    id=id,
                    banner_image=banner_image,
                    section_id=section,
                    redirect_url=redirect_url,
                    status=status,
                    updated_at=datetime.now()
                )

                # Save the object to the database
                banner.save(update_fields=["banner_image","section","redirect_url","status","updated_at"])
                banner.save()
            else:
                 # Create a new ExamCategory object
                category = Banners(
                    id=id,
                    section_id=section,
                    redirect_url=redirect_url,
                    status=status,
                    updated_at=datetime.now()
                )

                # Save the object to the database
                banner.save(update_fields=["section","redirect_url","status"])
            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'banner saved successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})


def delete_banner(request):  
   
    id = request.POST.get('id')
    Banners(id).soft_delete()
    return JsonResponse({'status': 'success', 'msg': 'banner deleted successfully.'})
# ============================end banner=============================
# ======================== create course =================
def courses(request):
    all_categories = ExamCategory.objects.select_related('exam_category')
    all_exams = Exam_Master.objects.select_related('exam_master')
    courses = Course.objects.all()
    paginator = Paginator(courses, 10)  # Show 25 contacts per page.
    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "course-list.html",{'courses':page_obj,'all_categories':all_categories,'all_exams':all_exams})

def course_create(request):
    all_categories = ExamCategory.objects.all()
    all_exams = Exam_Master.objects.all()
    if request.method == 'POST':
        # Process form data and create a new course
        course_id = request.POST.get('course_id')
        course_name = request.POST.get('course_name')
        image = request.FILES.get('image')
        exam_type_id = request.POST.get('exam_type')
        exam_master_id = request.POST.get('exam_master')
        duration = request.POST.get('duration')
        # batch_id = request.POST.get('batch_id')
        description = request.POST.get('description')
        area_price = request.POST.get('area_price')
        sectional_price = request.POST.get('sectional_price')
        minimock_price = request.POST.get('minimock_price')
        fullmock_price = request.POST.get('fullmock_price')
        lectures_price = request.POST.get('lectures_price')
        full_price = request.POST.get('full_price')
        status = request.POST.get('status')
        if(course_name==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter course name'})
        elif(image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select course image'})
        elif(exam_type_id==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select exam category'})
        elif(exam_master_id==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select exam master'})
        elif(duration==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter course duration'})
        elif(description==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter course description'})
        elif(area_price==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter area price'})
        elif(sectional_price==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter sectional price'})
        elif(minimock_price==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter minimock price'})
        elif(fullmock_price==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter full mock price'})
        elif(lectures_price==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter lecture price'})
        elif(full_price==''):
            return JsonResponse({'status': 'error', 'msg': 'Please enter full price'})
        elif(status==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select status.'})
        else:
            if course_id == '':
                course = Course(
               
                course_name=course_name,
                image=image,
                exam_category_id=exam_type_id,
                exam_master_id=exam_master_id,
                duration=duration,
                description=description,
                area_price=area_price,
                sectional_price=sectional_price,
                minimock_price=minimock_price,
                fullmock_price=fullmock_price,
                lectures_price=lectures_price,
                full_price=full_price,
                status=status
            )
                course.save()
            else :
                course = Course(
                id=course_id,
                course_name=course_name,
                image=image,
                exam_category_id=exam_type_id,
                exam_master_id=exam_master_id,
                duration=duration,
                description=description,
                area_price=area_price,
                sectional_price=sectional_price,
                minimock_price=minimock_price,
                fullmock_price=fullmock_price,
                lectures_price=lectures_price,
                full_price=full_price,
                status=status
                )
                course.save(update_fields=["course_name","image","exam_category_id","exam_master_id","duration","description","area_price","sectional_price","minimock_price","fullmock_price","lectures_price","full_price","status","updated_at"])
            return JsonResponse({'status': 'success', 'msg': 'Course Created successfully.'})
    else:
        
        # Render the add form
        return render(request, 'course_form.html', {'form_title': 'Add Course','submit_button': 'Add Course','all_categories':all_categories,'all_exams':all_exams ,'status': 'error', 'msg': 'Something went wrong.'})
    
def course_edit(request, course_id):
    course = get_object_or_404(Course, pk=course_id)
    all_categories = ExamCategory.objects.all()
    all_exams = Exam_Master.objects.all()
    if request.method == 'POST':
        # Process form data and update the existing course
        course.course_id = request.POST.get('course_id')
        course.course_name = request.POST.get('course_name')
        image = request.FILES.get('image')
        if image:
            course.image = image
        course.exam_type_id = request.POST.get('exam_type')
        course.exam_master_id = request.POST.get('exam_master')
        course.duration = request.POST.get('duration')
        course.batch_id = request.POST.get('batch_id')
        course.description = request.POST.get('description')
        course.area_price = request.POST.get('area_price')
        course.sectional_price = request.POST.get('sectional_price')
        course.minimock_price = request.POST.get('minimock_price')
        course.fullmock_price = request.POST.get('fullmock_price')
        course.lectures_price = request.POST.get('lectures_price')
        course.full_price = request.POST.get('full_price')
        course.status = request.POST.get('status')
        course.save()

        return JsonResponse({'success': True})
    else:
        # Render the edit form
        return render(request, 'course_form.html', {'form_title': 'Edit Course','submit_button': 'Save Course', 'course': course,'all_categories':all_categories,'all_exams':all_exams})

def select_exam_category(request): 
    exam_category_id = request.GET.get('exam_category_id')
    exam_master = Exam_Master.objects.filter(exam_category_id=exam_category_id)
    return render(request, "select_exam_master.html" ,{'exam_master':exam_master})


def delete_course(request):
     id = request.POST.get('course_id')
    #  print(id)
     Course(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'Course deleted successfully.'})


# =============================end courses module========================

# ======================= start media module ==============================
def media(request):
    # all_categories = ExamCategory.objects.all()
    all_media = MediaModule.objects.all()
    paginator = Paginator(all_media, 20)  # Show 25 contacts per page.
    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return render(request, "media.html",{'all_media':page_obj})
    #  return render(request, "media.html")

def addMedia(request):
    if request.method == 'POST':
        image = request.FILES.getlist('image')
        print(image)
        if(image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select images'})
        else:    
            for media_image in image:
                media = MediaModule(
                    image=media_image,   
                )
                media.save()

                # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Images Uploaded successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})

def editMedia(request):
    if request.method == 'POST':
        id = request.POST.get('id')
        image = request.FILES.get('image')
        if(image==''):
            return JsonResponse({'status': 'error', 'msg': 'Please select images'})
        else:    
            # Create a new ExamCategory object
            media = MediaModule(
                id=id,
                image=image,   
            )

            media.save(update_fields=["image"])

            # Return a success response
            return JsonResponse({'status': 'success', 'msg': 'Images Uploaded successfully.'})
    else:
        # Return an error response
            return JsonResponse({'status': 'error', 'msg': 'Something went wrong.'})



def deleteMediabyId(request):
     id = request.POST.get('id')
    #  print(id)
     MediaModule(id).soft_delete()
     return JsonResponse({'status': 'success', 'msg': 'Media deleted successfully.'})


# ======================= end media module  ==============================