from django.views.decorators.csrf import csrf_exempt
from django.http import JsonResponse
from django.core.paginator import Paginator
from learn.models import Banners, Blogs,Blog_category, Course, Exam_Master
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework_simplejwt.tokens import RefreshToken
from django.contrib.auth import authenticate
from .app_serializers.serializers import StudentSerializer,BlogCategorySerializer

class LoginView(APIView):
    def post(self, request):
        email = request.data.get('email')
        password = request.data.get('password')

        student = authenticate(request, email=email, password=password)
        if student is not None:
            serializer = StudentSerializer(student)
            refresh = RefreshToken.for_user(student)
            return Response({'token': str(refresh.access_token), 'student': serializer.data})
        else:
            return Response({'error': 'Invalid email or password'}, status=401)

# @csrf_exempt
class BlogCategoryView(APIView):
    def blog_category(self, request):
        blog_category = Blog_category.objects.all()
        # all_blogs = Blogs.objects.all()
        paginator = Paginator(blog_category, 10)  # Show 10 contacts per page.

        page_number = request.GET.get("page")
        page_obj = BlogCategorySerializer(paginator.get_page(page_number))
        #refresh = RefreshToken.for_user(student)
        return Response({'blog_categories': page_obj.data})

def blog_list(request):
    blog_category = Blog_category.objects.all()
    all_blogs = Blogs.objects.all()
    paginator = Paginator(all_blogs, 10)  # Show 10 contacts per page.

    page_number = request.GET.get("page")
    page_obj = paginator.get_page(page_number)
    return JsonResponse(page_obj)

# @csrf_exempt
def home(request):
    all_banner = Banners.objects.filter(status='Active')
    all_courses = Course.objects.filter(status='Active')
    all_blogs = Blogs.objects.filter(blog_status='Active')
    all_exams = Exam_Master.objects.select_related('exam_master')

    # paginator = Paginator(all_blogs, 10)  # Show 10 contacts per page.
    # page_number = request.GET.get("page")
    # page_obj = paginator.get_page(page_number)

    return JsonResponse(all_banner,all_courses,all_blogs,all_exams)