# Generated by Django 4.2.1 on 2023-05-17 10:43

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Batch_Management",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("batch_name", models.CharField(default="Null", max_length=255)),
                ("couse_name", models.CharField(default="Null", max_length=255)),
                ("status", models.CharField(default="Null", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Blog_category",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("category_name", models.CharField(default="Null", max_length=255)),
                (
                    "blog_category_image",
                    models.ImageField(
                        default="NULL", upload_to="learn/blog_category_images/"
                    ),
                ),
                ("meta_title", models.CharField(default="Null", max_length=255)),
                ("meta_discription", models.CharField(default="Null", max_length=255)),
                ("slug", models.CharField(default="Null", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="ExamCategory",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                (
                    "exam_category_name",
                    models.CharField(default="NULL", max_length=255),
                ),
                (
                    "image",
                    models.ImageField(
                        default="NULL", upload_to="learn/exam_category_images/"
                    ),
                ),
                ("status", models.CharField(default="NULL", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Faculty",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("faculty_name", models.CharField(default="Null", max_length=255)),
                ("email", models.CharField(default="Null", max_length=255)),
                ("password", models.CharField(default="Null", max_length=255)),
                ("contact", models.CharField(default="Null", max_length=255)),
                ("experience", models.CharField(default="Null", max_length=255)),
                ("date_of_birth", models.DateField(default="Null", max_length=255)),
                ("status", models.CharField(default="Null", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Sections",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("section_name", models.CharField(default="NULL", max_length=255)),
                ("display_order", models.CharField(default="NULL", max_length=255)),
                ("status", models.CharField(default="NULL", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Sub_Sections",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("sub_section_name", models.CharField(default="NULL", max_length=255)),
                ("display_order", models.CharField(default="NULL", max_length=255)),
                ("status", models.CharField(default="NULL", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "section",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.sections",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Topics",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("topic_name", models.CharField(default="NULL", max_length=255)),
                ("display_order", models.CharField(default="NULL", max_length=255)),
                ("status", models.CharField(default="NULL", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "section",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.sections",
                    ),
                ),
                (
                    "sub_section",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.sub_sections",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Students",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("first_name", models.CharField(default="Null", max_length=255)),
                ("last_name", models.CharField(default="Null", max_length=255)),
                ("email", models.CharField(default="Null", max_length=255)),
                ("mobile", models.CharField(default="Null", max_length=255)),
                ("address", models.CharField(default="Null", max_length=255)),
                ("landmark", models.CharField(default="Null", max_length=255)),
                ("city", models.CharField(default="Null", max_length=255)),
                ("state", models.CharField(default="Null", max_length=255)),
                ("pincode", models.CharField(default="Null", max_length=255)),
                ("remark", models.CharField(default="Null", max_length=255)),
                ("status", models.CharField(default="Null", max_length=255)),
                ("is_lead", models.IntegerField(default=0)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "batch",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.batch_management",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Question_Bank",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("question_type", models.CharField(default="NULL", max_length=255)),
                ("difficulty_level", models.CharField(default="NULL", max_length=255)),
                ("time_to_speed", models.CharField(default="NULL", max_length=255)),
                ("question", models.CharField(default="NULL", max_length=255)),
                ("explanation", models.CharField(default="NULL", max_length=255)),
                ("status", models.CharField(default="NULL", max_length=255)),
                (
                    "question_file",
                    models.ImageField(default="NULL", upload_to="learn/question/"),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "section",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.sections",
                    ),
                ),
                (
                    "sub_section",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.sub_sections",
                    ),
                ),
                (
                    "topic",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.topics",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Mock_Test",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("mock_title", models.CharField(default="NULL", max_length=255)),
                ("mock_type", models.CharField(default="NULL", max_length=255)),
                ("mock_level", models.CharField(default="NULL", max_length=255)),
                ("mock_duration", models.CharField(default="NULL", max_length=255)),
                ("pass_per", models.CharField(default="NULL", max_length=255)),
                ("negative_marks", models.CharField(default="NULL", max_length=255)),
                ("instruction_page", models.CharField(default="NULL", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "examcategory",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.examcategory",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Blogs",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_deleted", models.BooleanField(default=False)),
                ("blog_title", models.CharField(default="Null", max_length=255)),
                (
                    "blog_image",
                    models.ImageField(default="NULL", upload_to="learn/blog_image/"),
                ),
                ("blog_discription", models.CharField(default="Null", max_length=255)),
                ("blog_status", models.CharField(default="Null", max_length=255)),
                ("meta_title", models.CharField(default="Null", max_length=255)),
                ("meta_discription", models.CharField(default="Null", max_length=255)),
                ("slug", models.CharField(default="Null", max_length=255)),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "category",
                    models.ForeignKey(
                        default="NULL",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="learn.blog_category",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
