# Generated by Django 4.2 on 2023-05-24 10:23

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('learn', '0004_option'),
    ]

    operations = [
        migrations.CreateModel(
            name='Exam_Master',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_deleted', models.BooleanField(default=False)),
                ('exam_name', models.CharField(default='NULL', max_length=255)),
                ('image', models.ImageField(default='NULL', upload_to='learn/exam_master_images/')),
                ('banner', models.ImageField(default='NULL', upload_to='learn/exam_master_banner_images/')),
                ('marks_per_question', models.FloatField()),
                ('negative_marks_per_question', models.FloatField()),
                ('status', models.CharField(default='NULL', max_length=255)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now_add=True)),
                ('exam_category', models.ForeignKey(default='NULL', on_delete=django.db.models.deletion.CASCADE, to='learn.examcategory')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='MediaModule',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_deleted', models.BooleanField(default=False)),
                ('image', models.ImageField(default='NULL', upload_to='learn/media/')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='students',
            name='password',
            field=models.CharField(default='Null', max_length=255),
        ),
        migrations.CreateModel(
            name='Live_Lecture',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_deleted', models.BooleanField(default=False)),
                ('title', models.CharField(default='Null', max_length=255)),
                ('subject', models.CharField(default='Null', max_length=255)),
                ('image', models.ImageField(default='Null', upload_to='learn/live_lecture_images/')),
                ('lacture_id', models.CharField(default='Null', max_length=255)),
                ('lacture_date', models.DateField(default='Null', max_length=255)),
                ('start_time', models.TimeField(default='Null', max_length=255)),
                ('end_time', models.TimeField(default='Null', max_length=255)),
                ('password', models.CharField(default='Null', max_length=255)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now_add=True)),
                ('batch', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='learn.batch_management')),
                ('faculty', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='learn.faculty')),
                ('topic', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='learn.topics')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Exam_Subjects',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now_add=True)),
                ('exam', models.ForeignKey(default='NULL', on_delete=django.db.models.deletion.CASCADE, to='learn.exam_master')),
                ('section', models.ForeignKey(default='NULL', on_delete=django.db.models.deletion.CASCADE, to='learn.sections')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Course',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_deleted', models.BooleanField(default=False)),
                ('course_name', models.CharField(max_length=500)),
                ('image', models.ImageField(upload_to='course_images/')),
                ('duration', models.IntegerField()),
                ('description', models.TextField()),
                ('area_price', models.DecimalField(decimal_places=2, max_digits=8)),
                ('sectional_price', models.DecimalField(decimal_places=2, max_digits=8)),
                ('minimock_price', models.DecimalField(decimal_places=2, max_digits=8)),
                ('fullmock_price', models.DecimalField(decimal_places=2, max_digits=8)),
                ('lectures_price', models.DecimalField(decimal_places=2, max_digits=8)),
                ('full_price', models.DecimalField(decimal_places=2, max_digits=8)),
                ('status', models.CharField(max_length=20)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('exam_category', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='learn.examcategory')),
                ('exam_master', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='learn.exam_master')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Banners',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_deleted', models.BooleanField(default=False)),
                ('banner_image', models.ImageField(default='NULL', upload_to='learn/banner_images/')),
                ('status', models.CharField(default='Null', max_length=255)),
                ('redirect_url', models.CharField(default='Null', max_length=255)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now_add=True)),
                ('section', models.ForeignKey(default='NULL', on_delete=django.db.models.deletion.CASCADE, to='learn.sections')),
            ],
            options={
                'abstract': False,
            },
        ),
    ]
